﻿using Bizgaze.CRM;
using Bizgaze.CRM.Visitors.Managers;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;
using Unibase.Data;
using Unibase.Data.Expressions;
using Unibase.Data.Sql;
using Unibase.Dependency;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;

namespace Bizgaze.CRM.Visitors.ActionProviders
{
    public class UpdateVisitorBeenHerePreAction : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.UpdateVisitorBeenHerePreAction";

            }
        }
        public string FormActionName
        {
            get
            {
                return "UpdateVisitorBeenHere";
            }
        }
        public string Description
        {
            get
            {
                return "Update Visitor Been Here PreAction";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.UpdateVisitorBeenHere;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PreAction;
            }
        }
        //public ActionResponse<ExpandoObject> Execute(ActionRequest request, object IdValue, ExpandoObject obj, List<Unibase.Platform.Forms.Requests.DocParameter> docParametersList, ref long defaultPKValue)
        //{
        //    return null;

        //}
        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest request, FormActionProviderObject providerObject)
        {
            var IdValue = providerObject.IdValue;
            var srequest = SelectRequest.FromRequest(request);
            var obj = providerObject.RequestObject;
            var returnresponse = new FormActionResponse();
           // var docParametersList = providerObject.DocParametersList;
            var defaultPKValue = providerObject.DefaultPKValue;
            var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
            var dictObj = obj as IDictionary<string, dynamic>;
            var MobileNumber = dictObj["mobilenumber"].ToString();
            //var select = new Unibase.Data.Sql.Select().Columns("bizgazecrm_visitors.visitorid").From("bizgazecrm_visitors").Where("mobilenumber", MobileNumber);
            //List<Parameter> param = new List<Parameter>();
            //param.Add(new Parameter("@mobilenumber", MobileNumber));
            //var Visitor = await GetDataTableAsync(srequest, select, param);
            long visitorid = 0;
            var sql = new Unibase.Data.Sql.Select("bizgazecrm_visitors").Columns("bizgazecrm_visitors.installedappid", "bizgazecrm_visitors.visitorid", "bizgazecrm_visitors.fullname", "bizgazecrm_visitors.mobilenumber", "bizgazecrm_visitors.emailid", "bizgazecrm_visitors.photourl", "unibase_stagestatus.stageStatusName", "unibase_stagestatus.RefStatusId").InnerJoin("unibase_stages", Exp.EqColumns("unibase_stages.stageid", "bizgazecrm_visitors.stageid")).InnerJoin("unibase_stagestatus", Exp.EqColumns("unibase_stagestatus.stagestatusid", "unibase_stages.stagestatusid")).Where("bizgazecrm_visitors.mobilenumber", MobileNumber);
            List<Parameter> paramsql = new List<Parameter>();
            paramsql.Add(new Parameter("@bizgazecrm_visitors.mobilenumber", MobileNumber));
            var dt = await GetDataTableAsync(srequest, sql, paramsql);
            var stageStatusName = "";
            if (dt.Rows.Count > 0)
            {
                stageStatusName = "CheckIn";               
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    visitorid = dt.Rows[i]["visitorid"];
                    var installedAppId = Convert.ToInt64(dt.Rows[i]["installedAppId"]);
                    var stage = await stageManager.GetStageByStageStatusAsync(srequest, installedAppId, stageStatusName);
                    var NewStageId = stage.Result.StageId;
                    var UpdateStage = new Update("bizgazecrm_visitors").Value("stageid", NewStageId).Where(Exp.Eq("visitorId", visitorid));
                    await _repository.ExecuteAsync(request, UpdateStage);
                }
                var updateValues = new Dictionary<string, object>();
                updateValues.Add("agreement", true);
                updateValues.Add("checkindate", DateTime.Now);
                var updateQry = new Update("bizgazecrm_visitors").Values(updateValues).Where(Exp.Eq("visitorid", visitorid));
                var ds = await _repository.ExecuteAsync(request, updateQry);                
                returnresponse.Obj = null;
                returnresponse.PkValue = defaultPKValue;
                
            }
            return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
        }


        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.UpdateVisitorBeenHere,
            };
            }
        }

    }
}
